#!/usr/bin/python -u
import time
import math
from playerc import *

c = playerc_client(None, 'localhost', 6665)
if c.connect() != 0:
	raise playerc_error_str()

p = playerc_position2d(c, 0)
if p.subscribe(PLAYERC_OPEN_MODE) != 0:
	raise playerc_error_str()

l = playerc_laser(c, 0)
if l.subscribe(PLAYERC_OPEN_MODE) != 0:
	raise playerc_error_str()

start = time.time()
frames = 0
state = 0
while True:
	if c.read() == None:
		raise playerc_error_str()
	runtime = time.time() - start
	frames += 1
	fps = frames / runtime
	print "\033[2J\033[1;1H"
	print "runtime: %.1f, fps: %.1f" % (runtime, fps), state
	print "Robot pose: (%.3f,%.3f,%.3f)" % (p.px, p.py, p.pa)
	print "scan count:", l.scan_count
	laserscanstr = 'laser scan: '
	for j in range(15):
		laserscanstr += '%.3f ' % l.ranges[j]
	print laserscanstr
	print
	if runtime > 2 and state == 0:
		state = 1
		p.set_cmd_vel(0.5, 0.1, 0, 1)
	if runtime > 7 and state == 1:
		state = 2
		p.set_cmd_vel(0.0, 0.0, 0.0, 1)
	if runtime > 9 and state == 2:
		state = 3
		p.set_cmd_pose(0.0, 0.0, 0.0, 1)
	if runtime > 17 and state == 3:
		state = 4
		p.set_cmd_pose(1, 0, 0.0, 1)
	if runtime > 24 and state == 4:
		state = 5
		p.set_cmd_pose(1.44, -0.56, 0.0, 1)

p.unsubscribe()
l.unsubscribe()
c.disconnect()
print "\n"