/**
 * Munich University of Applied Sciences, FB07 Computer Science
 * Master of Science - Computergraphics and Image Processing
 *
 * Robotics - Prof. Dr. Max Fischer
 * "Autonomous self-parking robot"
 * 
 * System: Linux, C++
 */

/**
 * USABILITY:
 *  Copyright (c) 2006 
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to
 * deal in the Software without restriction, including without limitation the
 * rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
 * sell copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
 * IN THE SOFTWARE.
 */

/**
 * Class Description:
 *	Program Configurations
 *
 * @author All
 */
  
// For AStarPlaner
#define GRID_WIDTH_STEPS			100
#define GRID_HEIGHT_STEPS			100
#define GRID_ANGLE_STEPS			200

#define COST_LEVEL_CHANGE			0
#define COST_DIRECTION_CHANGE			0

#define TARGET_X_THRESHOLD			0.05
#define TARGET_Y_THRESHOLD			0.05
#define TARGET_THETA_THRESHOLD			dtor(10)

// For Car
// The thresholds when driving to a certain target
#define DRIVE_TO_TARGET_X_THRESHOLD		0.02
#define DRIVE_TO_TARGET_Y_THRESHOLD		0.02
#define DRIVE_TO_TARGET_THETA_THRESHOLD		dtor(2)

// For Environment
// The thresholds to make the robot a little bit bigger (ensuring that we don't hit any obstacles)
#define COLLISION_STATE_WIDTH_THRESHOLD		0.05
#define COLLISION_STATE_LENGTH_THRESHOLD	0.05

#define START_POSITION_ADJUST_ADDITIONAL_X	-0.20
