#ifndef JOYSTICK_H
#define JOYSTICK_H

#include <string>

/*
	this class operates on a linux js-event-device
	typicalliy /dev/input/js0
	this device driver can be enabled in the linux kernel-
	config at 
	Device Drivers/Input Device support/Joystick interface
	the module will be called joydev
	
	modprobe joydev
	
	should load all needed modules
*/

#define JS_THROTTLE_AXIS 1 // 0
#define JS_STEERING_AXIS 0 // 1
#define JS_THROTTLE_THRESHOLD 0.1

class Joystick {
private:
	int fd;
public:
	// should be used read-only
	// range: 0..1
	double throttle;
	double steering;
	
	bool joystickFound;
	bool was_pressed;
	bool had_button_event;
	int pressedButton;

public:
	Joystick(std::string dev="/dev/input/js0");

	bool joystickSupported();
	bool wait_event(unsigned int ms=0);
};

#endif // JOYSTICK_H
