////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// 
// File:	Position.cpp
// Author:	Stefan Hertel
// Date:	03.04.2006
//
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include <math.h>
#include "Position.h"

// constructor
// consturct a new Positon
Position::Position()
: m_positionX( 0.0 )
, m_positionY( 0.0 )
, m_positionTheta( 0.0 )
{
}

// Construct a new Position
Position::Position( double x, double y, double theta)
: m_positionX( x )
, m_positionY( y )
, m_positionTheta( theta )
{
}

// copy constructor
Position::Position( const Position& rhs )
: m_positionX( rhs.getX() )
, m_positionY( rhs.getY() )
, m_positionTheta( rhs.getTheta() )
{
}

// operator = 
bool Position::operator=( const Position& rhs )
{
	set( rhs.getX(), rhs.getY(), rhs.getTheta() );
	return true;
}

// destructor
Position::~Position()
{
}

// Retrieve X
double Position::getX() const
{
	return m_positionX;
}

// Retrieve Y
double Position::getY() const
{
	return m_positionY;
}

// Retrieve Theta
double Position::getTheta() const
{
	return m_positionTheta;
}

// set the Postion by three double values
void Position::set( double x, double y, double theta )
{
	setX( x );
	setY( y );
	setTheta( theta );
}

Position Position::operator-(const Position& op) {
	return Position(m_positionX - op.m_positionX, m_positionY - op.m_positionY, m_positionTheta - op.m_positionTheta);
}

Position::operator double() {
	return sqrt(m_positionX * m_positionX + m_positionY * m_positionY);
}

std::ostream& operator <<(std::ostream& os, Position& p) {
	os << "(" << p.m_positionX << " / " << p.m_positionY << " / " << p.m_positionTheta << ")";
	return os;
}
