////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// 
// File:	Position.h
// Author:	Stefan Hertel
// Date:	03.04.2006
//
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#ifndef POSITION_H
#define POSITION_H

#include <iostream>

class Position
{
	friend std::ostream& operator <<(std::ostream& os, Position& p);

public:
	// constructor
	// consturct a new Positon
	Position();

	// Construct a new Position
	Position( double x, double y, double theta ); 

	// copy constructor
	Position( const Position& rhs );

	// operator = 
	bool operator=( const Position& rhs );

	// get difference between each Position-Member
	Position operator-( const Position& op);
	// get euclid distance of this Position to (0, 0)
	operator double();

	// destructor
	virtual ~Position();

	// Retrieve X
	double getX() const; 

	// Retrieve Y
	double getY() const;

	// Retrieve Theta
	double getTheta() const;

	// set the Postion by three double values
	void set( double x, double y, double theta );

	// set x
	void setX( double x ) { m_positionX = x; }

	// set y
	void setY( double y ) { m_positionY = y; }

	// set theta
	void setTheta( double theta ) { m_positionTheta = theta; }

protected:
private:

	// the x position
	double m_positionX;

	// the y position
	double m_positionY;

	// the theta angle (radians)
	double m_positionTheta;

};

std::ostream& operator <<(std::ostream& os, Position& p);

#endif // POSITION_H

