////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// 
// File:	RouteCommand.cpp
// Author:	Stefan Hertel
// Date:	03.04.2006
//
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include "RouteCommand.h"

// constuctors 
// create a new RouteCommand
RouteCommand::RouteCommand()
: m_driveDirection( driveDirectionForward )
, m_deltaT( 0.0 )
, m_deltaTheta( 0.0 )
{
}

// create a new RouteCommand
RouteCommand::RouteCommand( ENUMdriveDirection driveDirection, double deltaT, double deltaTheta)
: m_driveDirection( driveDirection )
, m_deltaT( deltaT )
, m_deltaTheta( deltaTheta )
{
}

// copy consturctor
RouteCommand::RouteCommand( const RouteCommand& rhs )
: m_driveDirection( rhs.getDrive() )
, m_deltaT( rhs.getTime() )
, m_deltaTheta( rhs.getDeltaTheta() )
{
}

// desturctor
RouteCommand::~RouteCommand()
{
}

// operator = 
bool RouteCommand::operator=( const RouteCommand& rhs )
{
	setDriveDirection( rhs.getDrive() );
	setTime( rhs.getTime() );
	setDeltaTheta( rhs.getDeltaTheta() );
	return true;
}
