////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// 
// File:	RouteCommand.h
// Author:	Stefan Hertel
// Date:	03.04.2006
//
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#ifndef ROUTECOMMAND_H
#define ROUTECOMMAND_H

enum ENUMdriveDirection
{
	driveDirectionForward	= 1,
	driveDirectionBackward	= 2
};

enum ENUMdriveSteering
{
	driveSteeringStraight = 10,
	driveSteeringLeft = 11,
	driveSteeringRight = 12
};

class RouteCommand 
{
public:
	// constuctors 
	// create a new RouteCommand
	RouteCommand();

	// create a new RouteCommand
	RouteCommand( ENUMdriveDirection driveDirection, double deltaT , double deltaTheta );

	// copy consturctor
	RouteCommand( const RouteCommand& rhs );

	// desturctor
	virtual ~RouteCommand();

	// operator = 
	bool operator=( const RouteCommand& rhs );

	// set the drive direction
	void setDriveDirection( ENUMdriveDirection driveDirection ) { m_driveDirection = driveDirection; }

	// get the dirve direction
	ENUMdriveDirection getDrive() const { return m_driveDirection; }

	// set the angle to turn
	void setDeltaTheta( double deltaTheta ) { m_deltaTheta = deltaTheta; }

	// get the angle to turn
	double getDeltaTheta() const { return m_deltaTheta; }

	// set the drive time
	void setTime( double deltaT ) { m_deltaT = deltaT; }

	// get the drive time
	double getTime() const { return m_deltaT; }

protected:

private:

	// the drive Direction
	ENUMdriveDirection m_driveDirection;

	// the time holding this direction
	double m_deltaT;

	// The angle to turn (difference between start position and end position)
	double m_deltaTheta;
};

#endif // ROUTECOMMAND_H
