#ifndef COLLISION_TEST_H
#define COLLISION_TEST_H

#include "cv.h" // nur fuer CvPoint
#include "Point.h"

#define COLLISION_TEST_VERSION "0.3"

// struct Point {
// 	double x;
// 	double y;
// };

/*
	int n = rectline_collision(
		Point* rect,           addresse des ersten punktes des rechtecks, gegen das alle anderen
		                         geprueft werden sollen (der roboter)
		                         bei rechtecken muss rect[0], rect[1], rect[2] und rect[3] definiert sein
		Point* others,         addresse des ersten punktes von der ersten linie.
		                         linie1: other[0], other[1]
		                         linie2: other[1], other[2]
		                         ... also linienzuege
		int others_count,        anzahl der punkte
		bool* collisions = NULL  optional ein boolean array mit others_count-1 booleans.
		                         wenn sich die erste linie mit dem rechteck ueberschneidet
		                         wird collisions[0] = true gesetzt
	);
	n gibt an, wieviel collisionen gefunden wurden. 
	wenn collisions == NULL ist, wird nur 0 oder 1 zurueckgegeben. (schneller!)
*/
int rectline_collision(Point* rect, Point* others, int others_count, bool* collisions = NULL);

/*
	int n = rectrect_collision(
		CvPoint* rect,           addresse des ersten punktes des rechtecks, gegen das alle anderen
		                         geprueft werden sollen (der roboter)
		                         bei rechtecken muss rect[0], rect[1], rect[2] und rect[3] definiert sein
		CvPoint* others,         addresse des ersten punktes vom ersten anderen rechteck.
		                         rechteck1: other[0], other[1], other[2] und other[3]
		                         rechteck2: other[4], other[5], other[6] und other[7]
		                         ...
		int others_count,        anzahl der anderen rechecke 
		                         others muss (others_count * 4) punkte beinhalten
		bool* collisions = NULL  optional ein boolean array mit others_count booleans.
		                         wenn sich das erste "andere" rechteck mit "rect" ueberschneidet
		                         wird collisions[0] = true gesetzt
	);
	n gibt an, wieviel collisionen gefunden wurden. 
	wenn collisions == NULL ist, wird nur 0 oder 1 zurueckgegeben.
*/
int rectrect_collision(CvPoint* rect, CvPoint* others, int others_count, bool* collisions = NULL);
int tritri_collision(CvPoint* triangle, CvPoint* others, int others_count, bool* collisions = NULL);


#endif
